/**************************************************************************

Copyright (c) 2016, Intel Corporation

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of Intel Corporation nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

***************************************************************************/

#ifndef DRIVER_DIAGNOSTICS_H_
#define DRIVER_DIAGNOSTICS_H_

/* Defines, Macros */

#define MAX_ETHERNET_SIZE 1518
#define TEST_PACKET_SIZE  1024

#if (DBG_LVL & DIAG)
#define PHY_LOOPBACK_ITERATIONS 10
#else /* ~(DBG_LVL & DIAG) */
#define PHY_LOOPBACK_ITERATIONS 10000
#endif /* (DBG_LVL & DIAG) */

// Make the code of the set/clear MAC LPBK functions more readable by introducing the following macro
#define RETURN_DEVICE_ERROR_ON_ERROR_STATUS(Stat) \
  if ((Stat) != I40E_SUCCESS) { \
    return EFI_DEVICE_ERROR; \
  }

/* Types */

#pragma pack(1)
// ethernet header structure of packet used in loopback test
typedef struct {
  UINT8 DestAddr[6];
  UINT8 SourceAddr[6];
  UINT8 Length[2];
} ETHERNET_HDR; 
#pragma pack()

#endif /* DRIVER_DIAGNOSTICS_H_ */

